package com.bundle.bundle_rave_pay;

import android.os.Parcel;
import android.os.Parcelable;


public class BundleCard implements Parcelable {
    private double amount;
    private String cvv;
    private String cardExpiry;
    private String cardNumber;
    private boolean saveCard;

    public BundleCard(double amount, String cvv, String cardExpiry, String cardNumber, boolean saveCard) {
        this.amount = amount;
        this.cvv = cvv;
        this.cardExpiry = cardExpiry;
        this.cardNumber = cardNumber;
        this.saveCard = saveCard;
    }

    protected BundleCard(Parcel in) {
        amount = in.readDouble();
        cvv = in.readString();
        cardExpiry = in.readString();
        cardNumber = in.readString();
        saveCard = in.readByte() != 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeDouble(amount);
        dest.writeString(cvv);
        dest.writeString(cardExpiry);
        dest.writeString(cardNumber);
        dest.writeByte((byte) (saveCard ? 1 : 0));
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public static final Creator<BundleCard> CREATOR = new Creator<BundleCard>() {
        @Override
        public BundleCard createFromParcel(Parcel in) {
            return new BundleCard(in);
        }

        @Override
        public BundleCard[] newArray(int size) {
            return new BundleCard[size];
        }
    };

    public double getAmount() {
        return amount;
    }

    public void setAmount(double amount) {
        this.amount = amount;
    }

    public String getCvv() {
        return cvv;
    }

    public void setCvv(String cvv) {
        this.cvv = cvv;
    }

    public String getCardExpiry() {
        return cardExpiry;
    }

    public void setCardExpiry(String cardExpiry) {
        this.cardExpiry = cardExpiry;
    }

    public String getCardNumber() {
        return cardNumber;
    }

    public void setCardNumber(String cardNumber) {
        this.cardNumber = cardNumber;
    }

    public boolean isSaveCard() {
        return saveCard;
    }

    public void setSaveCard(boolean saveCard) {
        this.saveCard = saveCard;
    }
}