package com.bundle.bundle_rave_pay;

import android.Manifest;
import android.annotation.TargetApi;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.RelativeLayout;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.viewpager.widget.ViewPager;

import com.bundle.bundle_rave_pay.account.AccountFragment;
import com.bundle.bundle_rave_pay.ach.AchFragment;
import com.bundle.bundle_rave_pay.banktransfer.BankTransferFragment;
import com.bundle.bundle_rave_pay.card.CardFragment;
import com.bundle.bundle_rave_pay.di.components.AppComponent;
import com.bundle.bundle_rave_pay.di.modules.AndroidModule;
import com.bundle.bundle_rave_pay.di.modules.NetworkModule;
import com.bundle.bundle_rave_pay.francMobileMoney.FrancMobileMoneyFragment;
import com.bundle.bundle_rave_pay.ghmobilemoney.GhMobileMoneyFragment;
import com.bundle.bundle_rave_pay.mpesa.MpesaFragment;
import com.bundle.bundle_rave_pay.rwfmobilemoney.RwfMobileMoneyFragment;
import com.bundle.bundle_rave_pay.ugmobilemoney.UgMobileMoneyFragment;
import com.bundle.bundle_rave_pay.uk.UkFragment;
import com.bundle.bundle_rave_pay.ussd.UssdFragment;
import com.bundle.bundle_rave_pay.zmmobilemoney.ZmMobileMoneyFragment;
import com.bundle.bundle_rave_pay.di.components.DaggerAppComponent;
import com.google.android.material.tabs.TabLayout;

import java.util.ArrayList;
import java.util.List;

import static android.view.View.GONE;
import static com.bundle.bundle_rave_pay.RaveConstants.LIVE_URL;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_ACCOUNT;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_ACH;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_BANK_TRANSFER;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_CARD;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_FRANCO_MOBILE_MONEY;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_GH_MOBILE_MONEY;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_MPESA;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_RW_MOBILE_MONEY;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_UK;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_USSD;
import static com.bundle.bundle_rave_pay.RaveConstants.PAYMENT_TYPE_ZM_MOBILE_MONEY;
import static com.bundle.bundle_rave_pay.RaveConstants.PERMISSIONS_REQUEST_READ_PHONE_STATE;
import static com.bundle.bundle_rave_pay.RaveConstants.RAVEPAY;
import static com.bundle.bundle_rave_pay.RaveConstants.RAVE_PARAMS;
import static com.bundle.bundle_rave_pay.RaveConstants.STAGING_URL;

public class OldRavePayActivity extends AppCompatActivity {

    public static String BASE_URL;
    public static int RESULT_SUCCESS = 111;
    public static int RESULT_ERROR = 222;
    public static int RESULT_CANCELLED = 333;
    ViewPager pager;
    TabLayout tabLayout;
    RelativeLayout permissionsRequiredLayout;
    View mainContent;
    Button requestPermsBtn;
    int theme;
    RavePayInitializer ravePayInitializer;
    MainPagerAdapter mainPagerAdapter;
    AppComponent appComponent;
    ArrayList<Integer> orderedPaymentTypesList;

    public AppComponent getAppComponent() {
        return appComponent;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        try {
            ravePayInitializer = getIntent().getParcelableExtra(RAVE_PARAMS);
        } catch (Exception e) {
            e.printStackTrace();
            Log.d(RAVEPAY, "Error retrieving initializer");
        }

        orderedPaymentTypesList = ravePayInitializer.getOrderedPaymentTypesList();
        buildGraph();

        theme = ravePayInitializer.getTheme();

        if (theme != 0) {
            try {
                setTheme(theme);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        setContentView(com.bundle.bundle_rave_pay.R.layout.activity_old_rave_pay);

        if (ravePayInitializer.isStaging() && ravePayInitializer.getShowStagingLabel()) {
            findViewById(com.bundle.bundle_rave_pay.R.id.stagingModeBannerLay).setVisibility(View.VISIBLE);
        }


        tabLayout = findViewById(com.bundle.bundle_rave_pay.R.id.sliding_tabs);
        pager = findViewById(com.bundle.bundle_rave_pay.R.id.pager);
        permissionsRequiredLayout = findViewById(com.bundle.bundle_rave_pay.R.id.rave_permission_required_layout);
        mainContent = findViewById(com.bundle.bundle_rave_pay.R.id.main_content);
        requestPermsBtn = findViewById(com.bundle.bundle_rave_pay.R.id.requestPermsBtn);

        mainPagerAdapter = new MainPagerAdapter(getSupportFragmentManager());
        List<RaveFragment> raveFragments = new ArrayList<>();

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_CARD)) {
            raveFragments.add(new RaveFragment(new CardFragment(), "Card"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_ACH) || orderedPaymentTypesList.contains(PAYMENT_TYPE_ACCOUNT)) {
            if (ravePayInitializer.getCountry().equalsIgnoreCase("us") && ravePayInitializer.getCurrency().equalsIgnoreCase("usd")) {
                raveFragments.add(new RaveFragment(new AchFragment(), "ACH"));
            } else if (ravePayInitializer.getCountry().equalsIgnoreCase("ng") && ravePayInitializer.getCurrency().equalsIgnoreCase("ngn")) {
                raveFragments.add(new RaveFragment(new AccountFragment(), "Account"));
            }
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_MPESA) && ravePayInitializer.getCurrency().equalsIgnoreCase("KES")) {
            raveFragments.add(new RaveFragment(new MpesaFragment(), "Mpesa"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_GH_MOBILE_MONEY) && ravePayInitializer.getCurrency().equalsIgnoreCase("GHS")) {
            raveFragments.add(new RaveFragment(new GhMobileMoneyFragment(), "GHANA MOBILE MONEY"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_ZM_MOBILE_MONEY)) {
            raveFragments.add(new RaveFragment(new ZmMobileMoneyFragment(), "ZAMBIA MOBILE MONEY"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_ACH) && ravePayInitializer.getCurrency().equalsIgnoreCase("UGX")) {
            raveFragments.add(new RaveFragment(new UgMobileMoneyFragment(), "UGANDA MOBILE MONEY"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_UK)) {
            raveFragments.add(new RaveFragment(new UkFragment(), "UK"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_FRANCO_MOBILE_MONEY)) {
            raveFragments.add(new RaveFragment(new FrancMobileMoneyFragment(), "Franc Mobile Money"));
        }

        if (orderedPaymentTypesList.contains(PAYMENT_TYPE_RW_MOBILE_MONEY)) {
            raveFragments.add(new RaveFragment(new RwfMobileMoneyFragment(), "RWANDA MOBILE MONEY"));
        }

        if (ravePayInitializer.getCountry().equalsIgnoreCase("ng") && ravePayInitializer.getCurrency().equalsIgnoreCase("ngn")) {
            if (orderedPaymentTypesList.contains(PAYMENT_TYPE_BANK_TRANSFER)) {
                raveFragments.add(new RaveFragment(new BankTransferFragment(), "Bank Transfer"));
            }
            if (orderedPaymentTypesList.contains(PAYMENT_TYPE_USSD)) {
                raveFragments.add(new RaveFragment(new UssdFragment(), "USSD"));
            }
        }

        mainPagerAdapter.setFragments(raveFragments);
        pager.setAdapter(mainPagerAdapter);

        tabLayout.setupWithViewPager(pager);

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            checkForRequiredPermissions();
        }

        requestPermsBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
                    requestPermissions(new String[]{Manifest.permission.READ_PHONE_STATE},
                            PERMISSIONS_REQUEST_READ_PHONE_STATE);
                }
            }
        });

    }

    private void buildGraph() {

        if (ravePayInitializer.isStaging()) {
            BASE_URL = STAGING_URL;
        } else {
            BASE_URL = LIVE_URL;
        }

        appComponent = DaggerAppComponent.builder()
                .androidModule(new AndroidModule(this))
                .networkModule(new NetworkModule(BASE_URL))
                .build();


    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        if (requestCode == PERMISSIONS_REQUEST_READ_PHONE_STATE) {
            if (grantResults.length > 0
                    && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

                mainContent.setVisibility(View.VISIBLE);
                permissionsRequiredLayout.setVisibility(GONE);

            } else {
                permissionsRequiredLayout.setVisibility(View.VISIBLE);
            }
        }
    }

    public RavePayInitializer getRavePayInitializer() {
        return ravePayInitializer;
    }

    @TargetApi(Build.VERSION_CODES.M)
    public void checkForRequiredPermissions() {

        if (checkSelfPermission(Manifest.permission.READ_PHONE_STATE)
                != PackageManager.PERMISSION_GRANTED) {
            permissionsRequiredLayout.setVisibility(View.VISIBLE);
        } else {
            permissionsRequiredLayout.setVisibility(GONE);
        }
    }

    @Override
    public void onBackPressed() {

        setResult(RavePayActivity.RESULT_CANCELLED, new Intent());
        super.onBackPressed();
    }


}

