//
//  CustomerBank.swift
//  RaveMobile
//
//  Created by Segun Solaja on 5/28/17.
//  Copyright © 2017 Segun Solaja. All rights reserved.
//

import UIKit

class Bank: NSObject,NSCoding {
    var bankCode:String?
    var isInternetBanking:Bool?
    var name:String?
    
    override init () {
        super.init()
    }
    
    func encode(with aCoder: NSCoder){
        aCoder.encode(bankCode, forKey: "bankCode")
        aCoder.encode(isInternetBanking, forKey: "isInternetBanking")
        aCoder.encode(name, forKey: "name")
           }
    
    required init(coder aDecoder: NSCoder){
        
        self.bankCode = aDecoder.decodeObject(forKey: "bankCode") as? String
        
        self.isInternetBanking = aDecoder.decodeObject(forKey: "isInternetBanking") as? Bool
        self.name = aDecoder.decodeObject(forKey: "name") as? String
    }
}

class BankTransferDetail {
    let flw_reference: String?
    let accountnumber: String?
    let bankname: String?
    let created_on: String?
    let expiry_date: String?
    let note: String?
    let amount: Double?
    
    var beneficiary: String {
        if let name = RavePayConfig.sharedConfig().merchantName {
            return name
        }
        guard let note = self.note,
        let startIndex = note.index(of: "to ") else { return "" }
        let index = note.index(note.startIndex, offsetBy: startIndex+3)
        return String(note[index...])
    }
    
    init(json: [String: Any]) {
        flw_reference = json["flw_reference"] as? String
        accountnumber = json["accountnumber"] as? String
        bankname = json["bankname"] as? String
        created_on = json["created_on"] as? String
        expiry_date = json["expiry_date"] as? String
        note = json["note"] as? String
        amount = json["amount"] as? Double
    }
}
