import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:bundle_rave_pay/bundle_rave_pay.dart';

void main() {
  const MethodChannel channel = MethodChannel('bundle_rave_pay');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return true;
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('initializePayment', () async {
    var cardBody = {
      "amount": "3200",
      "cvv": "470",
      "cardExpiry": "10/22",
      "cardNumber": "5399838383838381",
      "saveCard": "true",
      "country": "NG",
      "currencyCode": "NGN",
      "email": "hashilekky@gmail.com",
      "firstName": "Oluwaleke",
      "lastName": "Fakorede",
      "transactionReference": "testingLeke",
      "isLive": "false",
      "publicKey": "FLWPUBK-e634d14d9ded04eaf05d5b63a0a06d2f-X",
      "encryptionKey": "bb9714020722eb4cf7a169f2",
      "narration": "How are you doing?",
      "isCard": "true",
    };
    expect(await BundleRavePay.initializePayment(cardBody), true);
  });
}
